(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     13688,        345]
NotebookOptionsPosition[     12582,        303]
NotebookOutlinePosition[     13099,        325]
CellTagsIndexPosition[     13014,        320]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Establish", " ", "a", " ", "connection", " ", "to", " ", "SASImport"}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"mlink", " ", "=", " ", 
   RowBox[{
   "Install", "[", "\"\<C:\\\\SASImport\\\\release\\\\SASImport.exe\>\"", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.494317080141*^9, 3.4943171079709997`*^9}, {
  3.4945862353223886`*^9, 3.494586236728693*^9}, {3.4947439017684*^9, 
  3.4947439147114*^9}, {3.4947527897384*^9, 3.4947528059936*^9}, {
  3.4947569739406*^9, 3.4947569768716*^9}, {3.4948706279854*^9, 
  3.4948706307114*^9}, {3.5005397582*^9, 3.5005397705708*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Terminate", " ", "the", " ", "connection", " ", "to", " ", 
    RowBox[{"SASImport", " ", "--"}], " ", "Be", " ", "sure", " ", "to", " ", 
    "call", " ", "this", " ", "when", " ", "you", " ", "are", " ", "done", 
    " ", "making", " ", "calls", " ", "to", " ", 
    RowBox[{"SASImport", "[", "]"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"Uninstall", "[", "mlink", "]"}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Get", " ", "information", " ", "about", " ", "SASImport"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"?", " ", "SASImport"}]}]], "Input",
 CellChangeTimes->{{3.494317177783*^9, 3.494317194935*^9}, {
  3.4945376343746*^9, 3.4945376363096*^9}, {3.4947528120776*^9, 
  3.4947528251348*^9}, {3.5005397744552*^9, 3.500539780508*^9}}],

Cell[BoxData[
 StyleBox["\<\"SASImport[s] uses SAS Integration Technologies to open the SAS \
data set given by the path s.\"\>", "MSG"]], "Print", "PrintUsage",
 CellChangeTimes->{3.5005439400453997`*^9},
 CellTags->"Info3500525940-7665267"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Example", ":", " ", 
     RowBox[{"Open", " ", "a", " ", "SAS", " ", "data", " ", 
      RowBox[{"set", ".", "  ", "Note"}], " ", "that", " ", "this", " ", 
      "data", " ", "set", " ", "has", " ", "dates", " ", "and", " ", "in", 
      " ", "some", " ", "cases"}]}], ",", " ", 
    RowBox[{"the", " ", "records", " ", "have", " ", "missing", " ", 
     RowBox[{"values", ".", "  ", "If"}], " ", "a", " ", "record", " ", "in", 
     " ", "a", " ", "SAS", " ", "data", " ", "set", " ", "has", " ", "a", " ",
      "missing", " ", "value", " ", "in", " ", "a", " ", "particular", " ", 
     "field"}], ",", " ", 
    RowBox[{
    "then", " ", "that", " ", "record", " ", "is", " ", "imported", " ", 
     "with", " ", 
     RowBox[{"Missing", "[", "]"}], " ", "as", " ", "the", " ", "value", " ", 
     "for", " ", "the", " ", 
     RowBox[{"field", ".", "  ", "In"}], " ", "this", " ", "example"}], ",", 
    " ", 
    RowBox[{
    "date_found", " ", "is", " ", "missing", " ", "in", " ", "one", " ", 
     "record", " ", "and", " ", "weight", " ", "is", " ", "missing", " ", 
     "in", " ", "another", " ", 
     RowBox[{"record", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"sasData", " ", "=", " ", 
   RowBox[{
   "SASImport", "[", 
    "\"\<C:\\\\SASImport\\\\sample SAS data\\\\fossils.sas7bdat\>\"", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.494317319611*^9, 3.494317342093*^9}, {
   3.4943208870656*^9, 3.4943209047836*^9}, {3.494369701808*^9, 
   3.49436970304*^9}, 3.4945255767816*^9, {3.4945256270546*^9, 
   3.4945256278416*^9}, {3.4945339483072*^9, 3.4945339519421997`*^9}, 
   3.4945376426906*^9, {3.49458626738612*^9, 3.494586269573704*^9}, {
   3.4946074906737146`*^9, 3.494607493671334*^9}, {3.4946948399542837`*^9, 
   3.494694878046815*^9}, 3.494695096227333*^9, 3.4947448513766003`*^9, {
   3.5005397867792*^9, 3.5005398094927998`*^9}, {3.500539839517*^9, 
   3.500539854307*^9}, 3.5005485999632*^9, {3.5005742460814095`*^9, 
   3.5005742505897226`*^9}, 3.5005752323100433`*^9, {3.500575994102623*^9, 
   3.500575996591623*^9}, {3.5006229489704*^9, 3.5006229506874*^9}, {
   3.5006230411834*^9, 3.500623236182*^9}, 3.5006233292204*^9, 
   3.5006249879062*^9, {3.5006251791104*^9, 3.5006251800308*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Example", " ", "-", " ", 
    RowBox[{"continued", ":", " ", 
     RowBox[{
     "Convert", " ", "the", " ", "numeric", " ", "column", " ", "that", " ", 
      "represents", " ", "a", " ", "SAS", " ", "date", " ", "into", " ", "a", 
      " ", "Mathematica", " ", "date"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "The", " ", "SAS", " ", "System", " ", "represents", " ", "a", " ", 
     "date", " ", "as", " ", "the", " ", "number", " ", "of", " ", "days", 
     " ", "since", " ", "1", " ", "January", " ", "1960.", "  ", "In", " ", 
     "other", " ", "words"}], "..."}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"sasZeroHour", " ", "=", " ", 
   RowBox[{"AbsoluteTime", "[", 
    RowBox[{"{", 
     RowBox[{"1960", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], 
     "}"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5005743208975706`*^9, 3.500574388771866*^9}, {
  3.500575254882809*^9, 3.500575255148004*^9}, {3.500575407666271*^9, 
  3.500575436619314*^9}, {3.5005754725454235`*^9, 3.5005754729510155`*^9}, {
  3.5006232573668003`*^9, 3.5006232687548*^9}}],

Cell[BoxData["1893369600"], "Output",
 CellChangeTimes->{3.5005743912054186`*^9, 3.5006235080276003`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Since", " ", "the", " ", "first", " ", "field", " ", "of", " ", "each", 
     " ", "record", " ", "in", " ", "the", " ", "sasData", " ", "data", " ", 
     "set", " ", "is", " ", "a", " ", "date"}], ",", " ", 
    RowBox[{
    "we", " ", "want", " ", "to", " ", "convert", " ", "the", " ", "value", 
     " ", "of", " ", "that", " ", "into", " ", "a", " ", "Mathematica", " ", 
     RowBox[{"date", ".", "  ", "In"}], " ", "order", " ", "to", " ", "do", 
     " ", "this"}], ",", " ", 
    RowBox[{
    "we", " ", "shall", " ", "define", " ", "a", " ", "function", " ", 
     "which", " ", "replaces", " ", "the", " ", "first", " ", "element", " ", 
     "of", " ", "its", " ", "input", " ", "list", 
     RowBox[{"(", 
      RowBox[{
      "where", " ", "the", " ", "first", " ", "element", " ", "is", " ", 
       "assumed", " ", "to", " ", "be", " ", "a", " ", "numeric", " ", 
       "value", " ", "representing", " ", "a", " ", "SAS", " ", "date"}], 
      ")"}], " ", "\[IndentingNewLine]", "with", " ", "the", " ", 
     "corresponding", " ", "Mathematica", " ", 
     RowBox[{"date", ".", "  ", "However"}]}], ",", " ", 
    RowBox[{
    "if", " ", "the", " ", "date", " ", "valus", " ", "is", " ", "missing"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"we", " ", 
     RowBox[{"won", "'"}], "t", " ", "convert", " ", 
     RowBox[{"it", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"convertSASDateToMathematicaDate", "[", "aRecord_", "]"}], " ", ":=",
    " ", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"Count", "[", 
       RowBox[{
        RowBox[{"List", "[", 
         RowBox[{"First", "[", "aRecord", "]"}], "]"}], ",", "_Missing"}], 
       "]"}], "\[Equal]", "0"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Insert", "[", 
      RowBox[{
       RowBox[{"Rest", "[", "aRecord", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"DateString", "[", 
        RowBox[{
         RowBox[{"DatePlus", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
            "1960", ",", "1", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}],
            ",", 
           RowBox[{"First", "[", "aRecord", "]"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{
          "\"\<Day\>\"", ",", "\"\<MonthNameShort\>\"", ",", "\"\<Year\>\""}],
           "}"}]}], "]"}], ",", "1"}], "]"}], ",", "\[IndentingNewLine]", " ",
      "aRecord"}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5005744281455083`*^9, 3.5005747926012993`*^9}, {
  3.5005748238162994`*^9, 3.5005748335037127`*^9}, {3.5006233346804*^9, 
  3.500623397876*^9}, {3.5006236510327997`*^9, 3.5006236966004*^9}, {
  3.5006237575123997`*^9, 3.5006237591794*^9}, {3.5006238317854*^9, 
  3.5006238419884*^9}, {3.5006239935123997`*^9, 3.5006239966834*^9}, {
  3.5006242157674*^9, 3.5006242216624002`*^9}, {3.5006247198194*^9, 
  3.5006247519224*^9}, {3.5006247843803997`*^9, 3.5006248049674*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"For", " ", "example"}], ",", " ", 
    RowBox[{
     RowBox[{"SAS", "'"}], "s", " ", "zero", " ", "hour", " ", "is", " ", 
     RowBox[{"Jan", ".", " ", "1"}]}], ",", " ", 
    RowBox[{"1960", " ", "so", " ", "our", " ", "function"}], ",", " ", 
    RowBox[{
    "when", " ", "given", " ", "a", " ", "list", " ", "with", " ", "0", " ", 
     "as", " ", "its", " ", "first", " ", "element"}], ",", " ", 
    RowBox[{
    "should", " ", "produce", " ", "a", " ", "list", " ", "whose", " ", 
     "first", " ", "element", " ", "is", " ", "01", "Jan1960", " ", 
     "followed", " ", "by", " ", "the", " ", "original", " ", "elements", " ",
      "of", " ", "the", " ", "input", " ", 
     RowBox[{"list", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"convertSASDateToMathematicaDate", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", " ", "a", ",", "b", ",", "c"}], "}"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.5005748529721384`*^9, 3.5005750183757577`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"01Jan1960\"\>", ",", "a", ",", "b", ",", "c"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5005749320626173`*^9, 3.5006235136748*^9, 
  3.5006235853724003`*^9, 3.5006237036828003`*^9, 3.5006240042434*^9, 
  3.5006242299754*^9, 3.5006247605123997`*^9, 3.5006248133014*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"As", " ", "a", " ", "SAS", " ", "date"}], ",", " ", 
    RowBox[{"Feb", ".", " ", "8"}], ",", " ", 
    RowBox[{
     RowBox[{"1953", " ", "is", " ", "equal", " ", "to"}], " ", "-", 
     "2518"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"convertSASDateToMathematicaDate", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "2518"}], ",", " ", "a", ",", "b", ",", "c"}], "}"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.5006240231914*^9, 3.5006240473473997`*^9}, {
  3.5006248260534*^9, 3.5006249006984*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"\<\"08Feb1953\"\>", ",", "a", ",", "b", ",", "c"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5006240512953997`*^9, 3.5006247656994*^9, 
  3.5006249029304*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "The", " ", "actual", " ", "data", " ", "begins", " ", "with", " ", "the", 
    " ", "second", " ", "record", " ", "in", " ", "our", " ", "original", " ",
     "result", " ", 
    RowBox[{"set", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"sasDataOnly", " ", "=", " ", 
   RowBox[{"Rest", "[", "sasData", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.500575044988846*^9, 3.500575128899632*^9}, {
  3.5006234323052*^9, 3.5006234638640003`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Using", " ", "the", " ", "Mathematica", " ", 
     RowBox[{"Map", "[", "]"}], " ", "function"}], ",", " ", 
    RowBox[{
    "we", " ", "can", " ", "now", " ", "convert", " ", "the", " ", "data", 
     " ", "we", " ", "imported", " ", "so", " ", "that", " ", "SAS", " ", 
     "dates", " ", "are", " ", "replaced", " ", "with", " ", "Mathematica", 
     " ", "dates"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"sasDataWithDatesConverted", " ", "=", " ", 
   RowBox[{"Map", "[", 
    RowBox[{"convertSASDateToMathematicaDate", ",", "sasDataOnly"}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.5005752948648405`*^9, 3.5005753532701173`*^9}, {
   3.5006234197316*^9, 3.5006234217752*^9}, {3.5006234781535997`*^9, 
   3.500623489058*^9}, 3.5006235943268003`*^9}]
},
WindowSize->{955, 511},
WindowMargins->{{24, Automatic}, {37, Automatic}},
ShowSelection->True,
FrontEndVersion->"7.0 for Microsoft Windows (32-bit) (February 18, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "Info3500525940-7665267"->{
  Cell[2079, 58, 242, 4, 40, "Print",
   CellTags->"Info3500525940-7665267"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"Info3500525940-7665267", 12912, 314}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 653, 14, 52, "Input"],
Cell[1201, 36, 454, 8, 52, "Input"],
Cell[CellGroupData[{
Cell[1680, 48, 396, 8, 52, "Input"],
Cell[2079, 58, 242, 4, 40, "Print",
 CellTags->"Info3500525940-7665267"]
}, Open  ]],
Cell[2336, 65, 2314, 43, 112, "Input"],
Cell[CellGroupData[{
Cell[4675, 112, 1188, 25, 72, "Input"],
Cell[5866, 139, 105, 1, 30, "Output"]
}, Open  ]],
Cell[5986, 143, 3006, 65, 212, "Input"],
Cell[CellGroupData[{
Cell[9017, 212, 1038, 21, 72, "Input"],
Cell[10058, 235, 314, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[10409, 246, 594, 15, 52, "Input"],
Cell[11006, 263, 199, 5, 30, "Output"]
}, Open  ]],
Cell[11220, 271, 513, 11, 52, "Input"],
Cell[11736, 284, 842, 17, 72, "Input"]
}
]
*)

(* End of internal cache information *)
